AnnotationsWindow = class(Turbine.UI.Lotro.Window);
function AnnotationsWindow:Constructor()
	Turbine.UI.Lotro.Window.Constructor( self );
	self:SetText(Resource[language][135]);
	self:SetVisible(false);
	self:SetSize(500,325);
	self:SetPosition((Turbine.UI.Display:GetWidth() - self:GetWidth()) / 2,(Turbine.UI.Display:GetHeight() - self:GetHeight()) / 2);

	self.AnnotationIndex=0;
	self.HadErrors=false;
	self.AnnotationsPanel=Turbine.UI.Control();
	self.AnnotationsPanel:SetParent(self);
	self.AnnotationsPanel:SetSize(self:GetWidth()-30,self:GetHeight()-100);
	self.AnnotationsPanel:SetPosition(15,40);
	self.AnnotationsPanel:SetBackColor(backColor);
	self.AnnotationsPanel:SetMouseVisible(false);

	self.AnnotationCaption=Turbine.UI.Label();
	self.AnnotationCaption:SetParent(self.AnnotationsPanel);
	self.AnnotationCaption:SetPosition(10,3);
	self.AnnotationCaption:SetSize(self.AnnotationsPanel:GetWidth()-350,18);
	self.AnnotationCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.AnnotationCaption:SetForeColor(fontColor);
	self.AnnotationCaption:SetText(Resource[language][136]..":");
	self.AnnotationCaption:SetMouseVisible(false);

	self.AnnotationList=GaranStuff.MoorMap.DropDownList();
	self.AnnotationList:SetParent(self.AnnotationsPanel);
	self.AnnotationList:SetPosition(self.AnnotationCaption:GetLeft()+self.AnnotationCaption:GetWidth()+2,self.AnnotationCaption.GetTop()-3);
	self.AnnotationList:SetSize(self.AnnotationsPanel:GetWidth()-(self.AnnotationCaption:GetWidth()+self.AnnotationCaption:GetLeft())-30,20);
	self.AnnotationList:SetBorderColor(trimColor);
	self.AnnotationList:SetCurrentBackColor(colorDarkGrey);
	self.AnnotationList:SetBackColor(backColor);
	self.AnnotationList:SetCurrentBackColor(backColor);
	self.AnnotationList:SetDropRows(5);

	local tmpIndex;
	local pos1;
	local localAnnotations={};

	self.AnnotationList:AddItem(Resource[language][142],0);
--annotations[#annotations+1]={1,-12.3,-20.9, 8, 8, 19, "Gramsfoot Map"}; -- Gramsfoot map

	for tmpIndex=1,#annotations do
		if annotations[tmpIndex][1]==mapWindow.CurrentMapID and annotations[tmpIndex][5]~=8 then
			tmpName=annotations[tmpIndex][7]
			if tmpName==nil or tmpName=="" then
				if annotations[tmpIndex][6]~=nil then
					if Resource[language][annotations[tmpIndex][6]]~=nil then
						tmpName=Resource[language][annotations[tmpIndex][6]]; -- use translated text if found
					elseif Resource[1][annotations[tmpIndex][6]]~=nil then
						tmpName=Resource[1][annotations[tmpIndex][6]]; -- fall back to english if translated text not found
					end
				end
			end
			pos1=string.find (tmpName,":",0,true);
			if (pos1~=nil)then
				tmpName=string.sub(tmpName,1,pos1-1);
			end
			localAnnotations[#localAnnotations+1]={tmpName,tmpIndex}
		end
	end
	-- now sort the annotations alphabetically
	table.sort(localAnnotations,function(arg1,arg2) if arg1[1]<arg2[1] then return(true) end end);

	for tmpIndex=1,#localAnnotations do
		self.AnnotationList:AddItem(localAnnotations[tmpIndex][1],localAnnotations[tmpIndex][2]);
	end


	self.AnnotationList.SelectedIndexChanged = function ()
		self:EditAnnotation(self.AnnotationList:GetValue());
	end

-- trim color
	self.TypeCaption=Turbine.UI.Label();
	self.TypeCaption:SetParent(self.AnnotationsPanel);
	self.TypeCaption:SetPosition(10,self.AnnotationCaption:GetTop()+self.AnnotationCaption:GetHeight()+9);
	self.TypeCaption:SetSize(self.AnnotationsPanel:GetWidth()-350,18);
	self.TypeCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.TypeCaption:SetForeColor(fontColor);
	self.TypeCaption:SetText(Resource[language][137]..":");
	self.TypeCaption:SetMouseVisible(false);

	self.TypeList=GaranStuff.MoorMap.DropDownList();
	self.TypeList:SetParent(self.AnnotationsPanel);
	self.TypeList:SetPosition(self.TypeCaption:GetLeft()+self.TypeCaption:GetWidth()+2,self.TypeCaption.GetTop()-3);
	self.TypeList:SetSize(self.AnnotationsPanel:GetWidth()-(self.TypeCaption:GetWidth()+self.TypeCaption:GetLeft())-30,20);
	self.TypeList:SetBorderColor(trimColor);
	self.TypeList:SetCurrentBackColor(colorDarkGrey);
	self.TypeList:SetBackColor(backColor);
	self.TypeList:SetCurrentBackColor(backColor);
	self.TypeList:SetDropRows(5);

	self.TypeList:AddItem(Resource[language][143],1);
	self.TypeList:AddItem(Resource[language][144],2);
	self.TypeList:AddItem(Resource[language][145],3);
	self.TypeList:AddItem(Resource[language][146],4);
	self.TypeList:AddItem(Resource[language][148],6);
	self.TypeList:AddItem(Resource[language][147],5);
	self.TypeList:AddItem(Resource[language][149],7);
--	self.TypeList:AddItem(Resource[language][150],8);-- we don't allow users to add "map destinations" since they are tied to specific items/locations
	self.TypeList:AddItem(Resource[language][151],11);
	self.TypeList:SetSelectedIndex(6);

	self.NSCoordCaption=Turbine.UI.Label();
	self.NSCoordCaption:SetParent(self.AnnotationsPanel);
	self.NSCoordCaption:SetPosition(10,self.TypeCaption:GetTop()+self.TypeCaption:GetHeight()+9);
	self.NSCoordCaption:SetSize(self.AnnotationsPanel:GetWidth()-350,18);
	self.NSCoordCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.NSCoordCaption:SetForeColor(fontColor);
	self.NSCoordCaption:SetText(Resource[language][138]..":");
	self.NSCoordCaption:SetMouseVisible(false);
	self.NSCoordText=Turbine.UI.Lotro.TextBox();
	self.NSCoordText:SetParent(self.AnnotationsPanel);
	self.NSCoordText:SetPosition(self.NSCoordCaption:GetLeft()+self.NSCoordCaption:GetWidth()+2,self.NSCoordCaption.GetTop());
	self.NSCoordText:SetSize(40,18);
	self.NSCoordText:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);

	self.EWCoordCaption=Turbine.UI.Label();
	self.EWCoordCaption:SetParent(self.AnnotationsPanel);
	self.EWCoordCaption:SetPosition(10,self.NSCoordCaption:GetTop()+self.NSCoordCaption:GetHeight()+9);
	self.EWCoordCaption:SetSize(self.AnnotationsPanel:GetWidth()-350,18);
	self.EWCoordCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.EWCoordCaption:SetForeColor(fontColor);
	self.EWCoordCaption:SetText(Resource[language][139]..":");
	self.EWCoordCaption:SetMouseVisible(false);
	self.EWCoordText=Turbine.UI.Lotro.TextBox();
	self.EWCoordText:SetParent(self.AnnotationsPanel);
	self.EWCoordText:SetPosition(self.EWCoordCaption:GetLeft()+self.EWCoordCaption:GetWidth()+2,self.EWCoordCaption.GetTop());
	self.EWCoordText:SetSize(40,18);
	self.EWCoordText:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);

	self.NameCaption=Turbine.UI.Label();
	self.NameCaption:SetParent(self.AnnotationsPanel);
	self.NameCaption:SetPosition(10,self.EWCoordCaption:GetTop()+self.EWCoordCaption:GetHeight()+9);
	self.NameCaption:SetSize(self.AnnotationsPanel:GetWidth()-350,18);
	self.NameCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.NameCaption:SetForeColor(fontColor);
	self.NameCaption:SetText(Resource[language][140]..":");
	self.NameCaption:SetMouseVisible(false);
	self.NameText=Turbine.UI.Lotro.TextBox();
	self.NameText:SetParent(self.AnnotationsPanel);
	self.NameText:SetPosition(self.NameCaption:GetLeft()+self.NameCaption:GetWidth()+2,self.NameCaption.GetTop());
	self.NameText:SetSize(self.AnnotationsPanel:GetWidth()-(self.NameCaption:GetWidth()+self.NameCaption:GetLeft())-30,18);
	self.NameText:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.NameText:SetMultiline(false);

	self.DescriptionCaption=Turbine.UI.Label();
	self.DescriptionCaption:SetParent(self.AnnotationsPanel);
	self.DescriptionCaption:SetPosition(10,self.NameCaption:GetTop()+self.NameCaption:GetHeight()+9);
	self.DescriptionCaption:SetSize(self.AnnotationsPanel:GetWidth()-350,18);
	self.DescriptionCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.DescriptionCaption:SetForeColor(fontColor);
	self.DescriptionCaption:SetText(Resource[language][141]..":");
	self.DescriptionCaption:SetMouseVisible(false);
	self.DescriptionText=Turbine.UI.Lotro.TextBox();
	self.DescriptionText:SetParent(self.AnnotationsPanel);
	self.DescriptionText:SetPosition(self.DescriptionCaption:GetLeft()+self.DescriptionCaption:GetWidth()+2,self.DescriptionCaption.GetTop());
	self.DescriptionText:SetSize(self.AnnotationsPanel:GetWidth()-(self.DescriptionCaption:GetWidth()+self.DescriptionCaption:GetLeft())-30,72);
	self.DescriptionText:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.DescriptionText:SetMultiline(true);

--** SAVE AND CANCEL
	self.SaveButton=Turbine.UI.Lotro.Button();
	self.SaveButton:SetParent(self);
	self.SaveButton:SetSize(100,20);
	self.SaveButton:SetPosition((self:GetWidth()-self.SaveButton:GetWidth()*2)/3,self:GetHeight()-35);
	self.SaveButton:SetText(Resource[language][11]);
	self.SaveButton.Click=function()
		local hasError=false;
		-- validate option values
-- verify that the coordinates land on the current map
-- verify that name is non-blank and contains no ":"
-- verify that description is non-blank

		if hasError then
			self.ErrorLabel:SetForeColor(Turbine.UI.Color(1,0,0));
			self.ErrorLabel:SetText(Resource[language][152]);
			self.ErrorLabel:SetVisible(true);
			self.HadErrors=true;
			self.ErrorFadeTime=Turbine.Engine:GetGameTime()+3;
			self:SetWantsUpdates(true);
		else
			local tmpAnnotationIndex;
			if self.AnnotationList:GetValue()==0 then
				-- if creating a new annotation, we need to figure out where to put it in the alphabetical list
				tmpAnnotationIndex=#annotations+1;
				annotations[tmpAnnotationIndex]={};
				annotations[tmpAnnotationIndex][1]=mapWindow.CurrentMapID;
				annotations[tmpAnnotationIndex][2]=tonumber(self.NSCoordText:GetText());
				annotations[tmpAnnotationIndex][3]=tonumber(self.EWCoordText:GetText());
				annotations[tmpAnnotationIndex][4]=self.TypeList:GetValue();
				annotations[tmpAnnotationIndex][5]=self.TypeList:GetValue();
				annotations[tmpAnnotationIndex][6]=nil;
				annotations[tmpAnnotationIndex][7]=self.NameText:GetText()..": "..LTrim(self.DescriptionText:GetText());
				self.AnnotationList:AddItem(self.NameText:GetText(),tmpAnnotationIndex);
				self.AnnotationList:SetSelectedIndex(self.AnnotationList.ListData:GetItemCount());
			else
				-- if modifying an existing annotation, only update the Coords and type if it is not a "default"
				tmpAnnotationIndex=self.AnnotationList:GetValue();
				if annotations[tmpAnnotationIndex][6]==nil then
					annotations[tmpAnnotationIndex][2]=tonumber(self.NSCoordText:GetText());
					annotations[tmpAnnotationIndex][3]=tonumber(self.EWCoordText:GetText());
					annotations[tmpAnnotationIndex][4]=self.TypeList:GetValue();
					annotations[tmpAnnotationIndex][5]=self.TypeList:GetValue();
				end
				-- -- we have no way of auto-translating, so that is the best we can do
				-- only update the name and description even if the type or coords were somehow enabled
				annotations[tmpAnnotationIndex][7]=self.NameText:GetText()..": "..LTrim(self.DescriptionText:GetText());
				self.AnnotationList.ListData:GetItem(self.AnnotationList.ListData:GetSelectedIndex()):SetText(self.NameText:GetText());
				self.AnnotationList.CurrentValue:SetText(self.NameText:GetText());
			end

--			self:SetVisible(false);
			self.ErrorLabel:SetForeColor(Turbine.UI.Color(0,1,0));
			self.ErrorLabel:SetText(Resource[language][153]);
			self.ErrorLabel:SetVisible(true);
			self.HadErrors=true;
			self.ErrorFadeTime=Turbine.Engine:GetGameTime()+3;
			self:SetWantsUpdates(true);

			mapWindow.NeedsRefresh=true;
			mapWindow:SetWantsUpdates(true);
		end
	end

	self.DeleteButton=Turbine.UI.Lotro.Button();
	self.DeleteButton:SetParent(self);
	self.DeleteButton:SetSize(100,20);
	self.DeleteButton:SetPosition(self.SaveButton:GetLeft()+self.SaveButton:GetWidth()+(self:GetWidth()-self.DeleteButton:GetWidth()*2)/3,self:GetHeight()-35);
	self.DeleteButton:SetText(Resource[language][156]);
	self.DeleteButton.Click=function()
		-- users can delete anything that shows up in the list since the list doesn't have map points :)
		if self.AnnotationList:GetValue()>0 then
			table.remove(annotations,self.AnnotationList:GetValue());
			-- we need to run through the AnnotationList data values and subtract 1 from any value > the one removed
			local tmpDelIndex;
			local tmpVal=self.AnnotationList:GetValue();
			for tmpDelIndex=2,self.AnnotationList.ListData:GetItemCount() do
				if self.AnnotationList.ListData:GetItem(tmpDelIndex):GetValue()>tmpVal then
					self.AnnotationList.ListData:GetItem(tmpDelIndex).DataValue=self.AnnotationList.ListData:GetItem(tmpDelIndex).DataValue-1;
				end
			end
			-- now remove the currently selected entry
			self.AnnotationList.ListData:RemoveItemAt(self.AnnotationList.ListData:GetSelectedIndex());
			-- now point to the "New" entry
			self.AnnotationList:SetSelectedIndex(1);

			self.ErrorLabel:SetForeColor(Turbine.UI.Color(0,1,0));
			self.ErrorLabel:SetText(Resource[language][157]);
			self.ErrorLabel:SetVisible(true);
			self.HadErrors=true;
			self.ErrorFadeTime=Turbine.Engine:GetGameTime()+3;
			self:SetWantsUpdates(true);

			mapWindow.NeedsRefresh=true;
			mapWindow:SetWantsUpdates(true);
		end
	end

	self.ErrorLabel=Turbine.UI.Label();
	self.ErrorLabel:SetParent(self);
	self.ErrorLabel:SetText("")
	self.ErrorLabel:SetSize(self:GetWidth()-30,18);
	self.ErrorLabel:SetPosition((self:GetWidth()-self.ErrorLabel:GetWidth())/2,self.SaveButton:GetTop()-self.ErrorLabel:GetHeight()-5);
	self.ErrorLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro18);
	self.ErrorLabel:SetForeColor(Turbine.UI.Color(1,0,0));
	self.ErrorLabel:SetVisible(false);
	self.ErrorLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.ErrorLabel:SetMouseVisible(false);

	self.VisibleChanged=function(sender,args)
		if self:IsVisible() then
			-- refresh the options status to reflect current values
			self:SetLanguage(language);
		end
	end
	self.Update=function(sender,args)
		if self.HadErrors then
			if Turbine.Engine:GetGameTime()>self.ErrorFadeTime then
				self:SetWantsUpdates(false);
				self.ErrorLabel:SetVisible(false);
				self.HadErrors=false
			end
		end
	end

	self.NSCoordText:SetZOrder(50);
	self.EWCoordText:SetZOrder(60);
	self.NameText:SetZOrder(70);
	self.DescriptionText:SetZOrder(80);

	self.TypeList:SetZOrder(90);
	self.AnnotationList:SetZOrder(100);

	self.SelectAnnotation=function(sender,annotationIndex)
		local tmpIndex;
		for tmpIndex=1,self.AnnotationList.ListData:GetItemCount() do
			if self.AnnotationList.ListData:GetItem(tmpIndex):GetValue()==annotationIndex then
				self.AnnotationList:SetSelectedIndex(tmpIndex);
				self:EditAnnotation(annotationIndex);
				break
			end
		end
	end
	self.EditAnnotation=function(sender,annotationIndex)
		local tmpName;
		local tmpDescription;
		local tmpIndex;
		self.AnnotationIndex=annotationIndex;

--annotations[#annotations+1]={1,-12.3,-20.9, 8, 8, 19, "Gramsfoot Map"}; -- Gramsfoot map
		self.TypeList:HideList();
		if annotationIndex==nil or annotationIndex==0 then
			self.TypeList:SetEnabled(true);
			self.NSCoordText:SetEnabled(true);
			self.EWCoordText:SetEnabled(true);
			self.NameText:SetEnabled(true);
			self.DescriptionText:SetEnabled(true);
		else
			tmpName=annotations[annotationIndex][7]
			if tmpName==nil or tmpName=="" then
				if annotations[annotationIndex][6]~=nil then
					if Resource[language][annotations[annotationIndex][6]]~=nil then
						tmpName=Resource[language][annotations[annotationIndex][6]]; -- use translated text if found
					elseif Resource[1][annotations[annotationIndex][6]]~=nil then
						tmpName=Resource[1][annotations[annotationIndex][6]]; -- fall back to english if translated text not found
					end
				end
			end
			pos1=string.find (tmpName,":",0,true);
			if (pos1~=nil)then
				tmpDescription=LTrim(string.sub(tmpName,pos1+1));
				tmpName=string.sub(tmpName,1,pos1-1);
			end

			for tmpIndex=1,self.TypeList.ListData:GetItemCount() do
				if self.TypeList.ListData:GetItem(tmpIndex):GetValue()==annotations[annotationIndex][4] then
					self.TypeList:SetSelectedIndex(tmpIndex);
					break;
				end
			end
			self.NSCoordText:SetText(annotations[annotationIndex][2])
			self.EWCoordText:SetText(annotations[annotationIndex][3])
			self.NameText:SetText(tmpName);
			self.DescriptionText:SetText(tmpDescription);
			if annotations[annotationIndex][6]==nil then
				self.TypeList:SetEnabled(true);
				self.NSCoordText:SetEnabled(true);
				self.EWCoordText:SetEnabled(true);
				self.NameText:SetEnabled(true);
				self.DescriptionText:SetEnabled(true);
			else
				self.TypeList:SetEnabled(false);
				self.NSCoordText:SetEnabled(false);
				self.EWCoordText:SetEnabled(false);
				self.NameText:SetEnabled(true);
				self.DescriptionText:SetEnabled(true);
			end
		end
	end

	self.SetTrimColor=function(sender,color)
	end
	self.SetBackColor=function(sender,color)
	end
	self.SetFontColor=function(sender,color)
	end
	self.SetHeadingsColor=function(sender,color)
	end
	self.SetListTextColor=function(sender,color)
	end

	self.SetLanguage=function()
		self:SetText(Resource[language][135]);
		self.AnnotationCaption:SetText(Resource[language][136]..":");
		self.AnnotationList.ListData:GetItem(1):SetText(Resource[language][142]);
		self.SaveButton:SetText(Resource[language][11]);
		self.TypeCaption:SetText(Resource[language][137]..":");

		self.TypeList.ListData:GetItem(1):SetText(Resource[language][143]);
		self.TypeList.ListData:GetItem(2):SetText(Resource[language][144]);
		self.TypeList.ListData:GetItem(3):SetText(Resource[language][145]);
		self.TypeList.ListData:GetItem(4):SetText(Resource[language][146]);
		self.TypeList.ListData:GetItem(5):SetText(Resource[language][148]);
		self.TypeList.ListData:GetItem(6):SetText(Resource[language][147]);
		self.TypeList.ListData:GetItem(7):SetText(Resource[language][149]);
		self.TypeList.ListData:GetItem(8):SetText(Resource[language][151]);

		self.NSCoordCaption:SetText(Resource[language][138]..":");
		self.EWCoordCaption:SetText(Resource[language][139]..":");
		self.NameCaption:SetText(Resource[language][140]..":");
		self.DescriptionCaption:SetText(Resource[language][141]..":");
		self.DeleteButton:SetText(Resource[language][156]);
	end
	self.MouseClick=function(sender,args)
		self.AnnotationList:HideList();
		self.TypeList:HideList();
	end
end
LTrim=function(srcString)
	while string.sub(srcString,1,1)==" " do
		srcString=string.sub(srcString,2);
	end
	return srcString;
end