-- all annotations have the form:{MapID, N/S, E/W, IconID, Type, TextID, Description}
-- Annotation Type follows the Map Filter types plus the Creep specific "Map In"
-- TextID is only valid for the defaults and will allow using the appropriately translated text value from Resource
-- Types:
-- 1=uncontestable home base (Grams, GV)
-- 2=fixed control, attackable base (Ost, DG)
-- 3=contestable base (LC, TR, TA, Isen, LC)
-- 4=contestable outpost (ROP,POP,SOP,AE,IsenOP)
-- 5=point of interest (STAB, WTAB, Grothum, HH, DC)
-- 6=minor fortification (EC,OC)
-- 7=Rez Circle
-- 8=Map in
-- 9=NPC

-- mapInfo is in the form {MapName,StringResourceID, ImageResourceID/Path, Height,Width,HFactor,HOffset,WFactor,WOffset}
-- HFactor and HOffset are used in the conversion from map coordinates to pixels: X=Height*HFactor+HOffset will convert coordinate "Height" to pixel "X"

-- iconInfo is in the form {StringResourceID, Height, Width, Image ResourceID/Path, Highlighted Image ResourceID/Path}

	local tmpIconInfo={};
	local tmpMapInfo={};
	tmpIconInfo[#tmpIconInfo+1]={101,36,36,"GaranStuff/MoorMap/Resources/MainBase.tga","GaranStuff/MoorMap/Resources/MainBase_hover.tga"}; --placeholder
	tmpIconInfo[#tmpIconInfo+1]={102,18,18,"GaranStuff/MoorMap/Resources/Base.tga","GaranStuff/MoorMap/Resources/Base_hover.tga"};
	tmpIconInfo[#tmpIconInfo+1]={103,18,18,"GaranStuff/MoorMap/Resources/Fort.tga","GaranStuff/MoorMap/Resources/Fort_hover.tga"};
	tmpIconInfo[#tmpIconInfo+1]={104,18,18,"GaranStuff/MoorMap/Resources/Outpost.tga","GaranStuff/MoorMap/Resources/Outpost_hover.tga"};
	tmpIconInfo[#tmpIconInfo+1]={105,18,18,"GaranStuff/MoorMap/Resources/POI.tga","GaranStuff/MoorMap/Resources/POI_hover.tga"};
	tmpIconInfo[#tmpIconInfo+1]={106,18,18,"GaranStuff/MoorMap/Resources/Stockade.tga","GaranStuff/MoorMap/Resources/Stockade_hover.tga"};
	tmpIconInfo[#tmpIconInfo+1]={107,18,18,"GaranStuff/MoorMap/Resources/Rez.tga","GaranStuff/MoorMap/Resources/Rez_hover.tga"};
	tmpIconInfo[#tmpIconInfo+1]={108,18,18,"GaranStuff/MoorMap/Resources/CrudeMap.tga","GaranStuff/MoorMap/Resources/CrudeMap_hover.tga"};
	tmpIconInfo[#tmpIconInfo+1]={109,18,18,"GaranStuff/MoorMap/Resources/PoorMap.tga","GaranStuff/MoorMap/Resources/PoorMap_hover.tga"};
	tmpIconInfo[#tmpIconInfo+1]={110,18,18,"GaranStuff/MoorMap/Resources/GoodMap.tga","GaranStuff/MoorMap/Resources/GoodMap_hover.tga"};
	tmpIconInfo[#tmpIconInfo+1]={111,18,18,"GaranStuff/MoorMap/Resources/NPC.tga","GaranStuff/MoorMap/Resources/NPC_hover.tga"};
	tmpIconInfo[#tmpIconInfo+1]={131,18,18,"GaranStuff/MoorMap/Resources/FreepMap.tga","GaranStuff/MoorMap/Resources/FreepMap_hover.tga"};
	tmpIconInfo[#tmpIconInfo+1]={134,18,18,"GaranStuff/MoorMap/Resources/UnearnedMap.tga","GaranStuff/MoorMap/Resources/UnearnedMap_hover.tga"};
	-- need to add all of the regular icons as well

	tmpMapInfo[1]={1,100,tonumber("0x41008133"),1024,768,63.6,1541,-63.6,-636};

	if tmpAnnotations==nil then tmpAnnotations={} end
	if #tmpAnnotations==0 then
		-- these are the default tmpAnnotations as of Feb 23rd 2011
		tmpAnnotations[#tmpAnnotations+1]={1,-12.1,-21.1, 1, 1, 19, ""}; -- Gramsfoot
		tmpAnnotations[#tmpAnnotations+1]={1,-12.3,-20.9, 8, 8, 113, ""}; -- Gramsfoot map
		tmpAnnotations[#tmpAnnotations+1]={1,-15.4,-20.1, 3, 3, 20, ""}; -- Lugz
		tmpAnnotations[#tmpAnnotations+1]={1,-17.6,-14.5, 3, 3, 21, ""}; -- TR
		tmpAnnotations[#tmpAnnotations+1]={1,-16.6,-17.3, 3, 3, 22, ""}; -- TA
		tmpAnnotations[#tmpAnnotations+1]={1,-20.7,-13.6, 1, 1, 23, ""}; -- GV
		tmpAnnotations[#tmpAnnotations+1]={1,-17.0,-22.4, 2, 2, 24, ""}; -- DG
		tmpAnnotations[#tmpAnnotations+1]={1,-16.0,-12.2, 2, 2, 25, ""}; -- Ost
		tmpAnnotations[#tmpAnnotations+1]={1,-12.2,-15.1, 3, 3, 26, ""}; -- Isen
		tmpAnnotations[#tmpAnnotations+1]={1,-19.3,-17.6, 3, 3, 27, ""}; -- LC
		tmpAnnotations[#tmpAnnotations+1]={1,-13.0,-12.7, 5, 5, 28, ""}; -- Grothum
		tmpAnnotations[#tmpAnnotations+1]={1,-19.8,-20.0, 5, 5, 29, ""}; -- Hoarhallow
		tmpAnnotations[#tmpAnnotations+1]={1,-19.3,-21.8, 4, 4, 30, ""}; -- POP
		tmpAnnotations[#tmpAnnotations+1]={1,-18.4,-20.1, 4, 4, 31, ""}; -- ROP
		tmpAnnotations[#tmpAnnotations+1]={1,-20.9,-17.0, 4, 4, 32, ""}; -- SOP
		tmpAnnotations[#tmpAnnotations+1]={1,-13.4,-18.1, 4, 4, 33, ""}; -- AEOP
		tmpAnnotations[#tmpAnnotations+1]={1,-14.5,-16.2, 4, 4, 34, ""}; -- Isen OP
		tmpAnnotations[#tmpAnnotations+1]={1,-18.0,-16.7, 6, 6, 35, ""}; -- EC
		tmpAnnotations[#tmpAnnotations+1]={1,-17.0,-18.6, 6, 6, 36, ""}; -- OC
		tmpAnnotations[#tmpAnnotations+1]={1,-17.4,-16.7, 5, 5, 37, ""}; -- STAB
		tmpAnnotations[#tmpAnnotations+1]={1,-16.5,-18.2, 5, 5, 38, ""}; -- WTAB
		tmpAnnotations[#tmpAnnotations+1]={1,-12.7,-18.5, 5, 5, 39, ""}; -- DC
		tmpAnnotations[#tmpAnnotations+1]={1,-17.0,-19.7, 7, 7, 40, ""}; -- Lugz Rez
		tmpAnnotations[#tmpAnnotations+1]={1,-15.8,-15.3, 7, 7, 41, ""}; -- TR Rez
		tmpAnnotations[#tmpAnnotations+1]={1,-16.8,-22.2, 5, 5, 42, ""}; -- Creep DoF entrance
		tmpAnnotations[#tmpAnnotations+1]={1,-16.2,-12.5, 5, 5, 43, ""}; -- Freep DoF entrance
		tmpAnnotations[#tmpAnnotations+1]={1,-14.6,-15.8, 8, 8, 44, ""}; -- Crude TR
		tmpAnnotations[#tmpAnnotations+1]={1,-17.1,-18.6, 8, 8, 45, ""}; -- Crude TA
		tmpAnnotations[#tmpAnnotations+1]={1,-16.1,-20.9, 8, 8, 46, ""}; -- Crude Lugz
		tmpAnnotations[#tmpAnnotations+1]={1,-18.3,-18.6, 8, 8, 47, ""}; -- Crude LC
		tmpAnnotations[#tmpAnnotations+1]={1,-13.4,-12.8, 8, 8, 48, ""}; -- Crude Isen
		tmpAnnotations[#tmpAnnotations+1]={1,-17.8,-15.3, 9, 8, 49, ""}; -- Poor TR
		tmpAnnotations[#tmpAnnotations+1]={1,-16.0,-17.0, 9, 8, 50, ""}; -- Poor TA
		tmpAnnotations[#tmpAnnotations+1]={1,-14.2,-21.0, 9, 8, 51, ""}; -- Poor Lugz
		tmpAnnotations[#tmpAnnotations+1]={1,-18.9,-17.9, 9, 8, 52, ""}; -- Poor LC
		tmpAnnotations[#tmpAnnotations+1]={1,-14.7,-14.5, 9, 8, 53, ""}; -- Poor Isen
		tmpAnnotations[#tmpAnnotations+1]={1,-15.7,-14.2, 10, 8, 54, ""}; -- Good TR
		tmpAnnotations[#tmpAnnotations+1]={1,-17.9,-18.1, 10, 8, 55, ""}; -- Good TA
		tmpAnnotations[#tmpAnnotations+1]={1,-14.5,-19.1, 10, 8, 56, ""}; -- Good Lugz
		tmpAnnotations[#tmpAnnotations+1]={1,-20.3,-16.8, 10, 8, 57, ""}; -- Good LC
		tmpAnnotations[#tmpAnnotations+1]={1,-11.5,-19.1, 10, 8, 58, ""}; -- Good Isen
		tmpAnnotations[#tmpAnnotations+1]={1,-17.2,-13.7, 11, 9, 59, ""}; -- Goldi
		tmpAnnotations[#tmpAnnotations+1]={1,-12.5,-16.6, 11, 9, 60, ""}; -- Gollival
		tmpAnnotations[#tmpAnnotations+1]={1,-19.0,-18.6, 5, 5, 61, ""}; -- Spider Den
		tmpAnnotations[#tmpAnnotations+1]={1,-19.0,-18.6, 11, 9, 62, ""}; -- Caragdal
		tmpAnnotations[#tmpAnnotations+1]={1,-19.0,-18.6, 11, 9, 63, ""}; -- Gorgoris
		tmpAnnotations[#tmpAnnotations+1]={1,-16.1,-21.0, 11, 9, 64, ""}; -- Mazauk
		tmpAnnotations[#tmpAnnotations+1]={1,-17.8,-17.5, 11, 9, 65, ""}; -- Rockwithers (sort of the middle of his patrol)
		-- HH NPCs
		tmpAnnotations[#tmpAnnotations+1]={1,-19.7,-19.6, 11, 9, 66, ""}; -- Tortmund Cliffside
		tmpAnnotations[#tmpAnnotations+1]={1,-19.6,-19.8, 11, 9, 67, ""}; -- Emerald Twospade
		tmpAnnotations[#tmpAnnotations+1]={1,-20.0,-20.1, 11, 9, 68, ""}; -- Mayor Wat Mudbottom
		tmpAnnotations[#tmpAnnotations+1]={1,-20.2,-20.1, 5, 5, 69, ""}; -- Brittleleaf Field
		tmpAnnotations[#tmpAnnotations+1]={1,-20.3,-19.7, 11, 9, 70, ""}; -- Ned Claybrick
		-- LC NPCs
		tmpAnnotations[#tmpAnnotations+1]={1,-19.3,-17.3, 11, 9, 71, ""}; -- Captain-General Bordagor
		tmpAnnotations[#tmpAnnotations+1]={1,-19.3,-17.3, 11, 9, 72, ""}; -- Lietenant Swithulf
		tmpAnnotations[#tmpAnnotations+1]={1,-19.3,-17.3, 11, 9, 73, ""}; -- First Marshal Nrdram
		tmpAnnotations[#tmpAnnotations+1]={1,-17.0,-18.5, 11, 9, 74, ""}; -- Soldier Pashum
		tmpAnnotations[#tmpAnnotations+1]={1,-17.1,-18.5, 11, 9, 75, ""}; -- Tyrant Uzulthrang
		-- DG NPCs
		tmpAnnotations[#tmpAnnotations+1]={1,-17.0,-22.2, 11, 9, 76, ""}; -- Taskmaster Gazgortag
		tmpAnnotations[#tmpAnnotations+1]={1,-17.0,-22.2, 11, 9, 77, ""}; -- Taskmaster Galinzarza
		tmpAnnotations[#tmpAnnotations+1]={1,-17.0,-22.2, 11, 9, 78, ""}; -- Taskmaster Zimarp
		tmpAnnotations[#tmpAnnotations+1]={1,-17.0,-22.2, 11, 9, 79, ""}; -- Soldier Brzdargum
		tmpAnnotations[#tmpAnnotations+1]={1,-17.1,-22.2, 11, 9, 80, ""}; -- Soldier Quilbb
		tmpAnnotations[#tmpAnnotations+1]={1,-16.5,-22.4, 11, 9, 81, ""}; -- Soldier Narfikskm
		tmpAnnotations[#tmpAnnotations+1]={1,-16.5,-22.4, 11, 9, 82, ""}; -- Taskmaster Hindulug
		tmpAnnotations[#tmpAnnotations+1]={1,-16.5,-22.6, 11, 9, 83, ""}; -- Taskmaster Fikdag
		tmpAnnotations[#tmpAnnotations+1]={1,-16.5,-22.6, 11, 9, 84, ""}; -- Chieftain Durulkum
		tmpAnnotations[#tmpAnnotations+1]={1,-16.9,-22.4, 11, 9, 85, ""}; -- Taskmaster Radsripsh (patroller)
		tmpAnnotations[#tmpAnnotations+1]={1,-16.7,-22.5, 11, 9, 86, ""}; -- Soldier Mogrzgor
		tmpAnnotations[#tmpAnnotations+1]={1,-16.8,-22.6, 11, 9, 87, ""}; -- Soldier Nurzrzfim
		tmpAnnotations[#tmpAnnotations+1]={1,-16.8,-22.7, 11, 9, 88, ""}; -- Soldier Azri
		tmpAnnotations[#tmpAnnotations+1]={1,-16.8,-22.7, 11, 9, 89, ""}; -- Soldier Fimzhorn
		tmpAnnotations[#tmpAnnotations+1]={1,-16.8,-22.7, 11, 9, 90, ""}; -- Taskmaster Ishdgalur
		tmpAnnotations[#tmpAnnotations+1]={1,-16.9,-22.7, 11, 9, 91, ""}; -- Fim the Worm
		tmpAnnotations[#tmpAnnotations+1]={1,-16.9,-22.7, 11, 9, 92, ""}; -- Taskmaster Gukthor
		tmpAnnotations[#tmpAnnotations+1]={1,-16.9,-22.6, 11, 9, 93, ""}; -- Soldier Olozer (patroller)
		tmpAnnotations[#tmpAnnotations+1]={1,-17.1,-22.5, 11, 9, 94, ""}; -- Chieftain Karnbugl
		tmpAnnotations[#tmpAnnotations+1]={1,-17.1,-22.5, 11, 9, 95, ""}; -- Chieftain Pushi
		tmpAnnotations[#tmpAnnotations+1]={1,-17.1,-22.6, 11, 9, 96, ""}; -- Gavran
		tmpAnnotations[#tmpAnnotations+1]={1,-17.1,-22.6, 11, 9, 97, ""}; -- Dolith
		tmpAnnotations[#tmpAnnotations+1]={1,-17.1,-22.7, 11, 9, 98, ""}; -- Tyrant Durgrat
		tmpAnnotations[#tmpAnnotations+1]={1,-17.1,-22.7, 11, 9, 99, ""}; -- Chieftain Durflaguz
		tmpAnnotations[#tmpAnnotations+1]={1,-20.9,-13.4, 12, 8, 132, ""}; -- Glan Vraig Mapin

		tmpAnnotations[#tmpAnnotations+1]={1,-18.4,-16.5, 5, 5, 159, ""}; -- XR
		tmpAnnotations[#tmpAnnotations+1]={1,-16.3,-18.9, 5, 5, 160, ""}; -- Lugz XR
		tmpAnnotations[#tmpAnnotations+1]={1,-19.6,-17.3, 5, 5, 161, ""}; -- SH
	end

function loadDefaults()
	local tmpIndex;
	if iconInfo==nil then iconInfo={} end
	-- remove all of the prior iconInfo records and load the tmpIconInfo records
	while #iconInfo>0 do
		table.remove(iconInfo,1);
	end
	for tmpIndex=1,#tmpIconInfo do
		iconInfo[#iconInfo+1]={tmpIconInfo[tmpIndex][1],tmpIconInfo[tmpIndex][2],tmpIconInfo[tmpIndex][3],tmpIconInfo[tmpIndex][4],tmpIconInfo[tmpIndex][5]};
	end

	if mapInfo==nil then mapInfo={} end
	while #mapInfo>0 do
		table.remove(mapInfo,1);
	end
	for tmpIndex=1,#tmpMapInfo do
		mapInfo[#mapInfo+1]={tmpMapInfo[tmpIndex][1],tmpMapInfo[tmpIndex][2],tmpMapInfo[tmpIndex][3],tmpMapInfo[tmpIndex][4],tmpMapInfo[tmpIndex][5],tmpMapInfo[tmpIndex][6],tmpMapInfo[tmpIndex][7],tmpMapInfo[tmpIndex][8],tmpMapInfo[tmpIndex][9]};
	end
	-- kind of overkill, but we should sort the mapInfo by first element since order is important in this table

	if annotations==nil then annotations={} end
	tmpIndex=1;
	while tmpIndex<=#annotations do
		if annotations[tmpIndex][6]~=nil then
			-- this is a default value, remove it
			table.remove(annotations,tmpIndex);
		else
			-- this is a user added value, preserve it
			tmpIndex=tmpIndex+1
		end
	end
	for tmpIndex=1,#tmpAnnotations do
		annotations[#annotations+1]={tmpAnnotations[tmpIndex][1],tmpAnnotations[tmpIndex][2],tmpAnnotations[tmpIndex][3],tmpAnnotations[tmpIndex][4],tmpAnnotations[tmpIndex][5],tmpAnnotations[tmpIndex][6],tmpAnnotations[tmpIndex][7]};
	end

	-- truncate the temp tables to save memory
	while #tmpIconInfo>0 do
		table.remove(tmpIconInfo,1);
	end
	tmpIconInfo=nil;
	while #tmpMapInfo>0 do
		table.remove(tmpMapInfo,1);
	end
	tmpMapInfo=nil;
	while #tmpAnnotations>0 do
		table.remove(tmpAnnotations,1);
	end
	tmpAnnotations=nil;
end