import "GaranStuff.MoorMap.ColorPicker"
-- need to create the options window
OptionsWindow = class(Turbine.UI.Lotro.Window);
function OptionsWindow:Constructor()
	Turbine.UI.Lotro.Window.Constructor( self );
	self:SetText(Resource[language][3]);
	self:SetVisible(false);
	self:SetSize(540,400);
	self:SetPosition((Turbine.UI.Display:GetWidth() - self:GetWidth()) / 2,(Turbine.UI.Display:GetHeight() - self:GetHeight()) / 2);

	self.HadErrors=false;
	self.OptionsPanel=Turbine.UI.Control();
	self.OptionsPanel:SetParent(self);
	self.OptionsPanel:SetSize(self:GetWidth()-30,self:GetHeight()-80);
	self.OptionsPanel:SetPosition(15,40);
	self.OptionsPanel:SetBackColor(backColor);

	self.OptionsCaption=Turbine.UI.Label();
	self.OptionsCaption:SetParent(self.OptionsPanel);
	self.OptionsCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro18);
	self.OptionsCaption:SetForeColor(headingsColor);
	self.OptionsCaption:SetSize(self.OptionsPanel:GetWidth(),20);
	self.OptionsCaption:SetPosition(0,0);
	self.OptionsCaption:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
	self.OptionsCaption:SetText(Resource[language][4]..":");

	self.LanguageCaption=Turbine.UI.Label();
	self.LanguageCaption:SetParent(self.OptionsPanel);
	self.LanguageCaption:SetPosition(10,self.OptionsCaption:GetTop()+self.OptionsCaption:GetHeight()+9);
	self.LanguageCaption:SetSize(self.OptionsPanel:GetWidth()-301,18);
	self.LanguageCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.LanguageCaption:SetForeColor(fontColor);
	self.LanguageCaption:SetText(Resource[language][5]..":");

	self.LanguageList=GaranStuff.MoorMap.DropDownList();
	self.LanguageList:SetParent(self.OptionsPanel);
	self.LanguageList:SetPosition(self.LanguageCaption:GetLeft()+self.LanguageCaption:GetWidth()+2,self.LanguageCaption.GetTop()-3);
	self.LanguageList:SetSize(self.OptionsPanel:GetWidth()-(self.LanguageCaption:GetWidth()+self.LanguageCaption:GetLeft())-65,20);
	self.LanguageList:SetBorderColor(trimColor);
	self.LanguageList:SetCurrentBackColor(colorDarkGrey);
	self.LanguageList:SetBackColor(backColor);
	self.LanguageList:SetCurrentBackColor(backColor);
	self.LanguageList:SetDropRows(5);

	local tmpLanguage;
	for tmpLanguage in pairs(Resource) do
		self.LanguageList:AddItem(Resource[tmpLanguage][1],tmpLanguage);
	end

	self.LanguageList.SelectedIndexChanged = function ()
		self:SetLanguage(self.LanguageList:GetValue());
	end

-- trim color
	self.TrimCaption=Turbine.UI.Label();
	self.TrimCaption:SetParent(self.OptionsPanel);
	self.TrimCaption:SetPosition(10,self.LanguageCaption:GetTop()+self.LanguageCaption:GetHeight()+9);
	self.TrimCaption:SetSize(self.OptionsPanel:GetWidth()-301,18);
	self.TrimCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.TrimCaption:SetForeColor(fontColor);
	self.TrimCaption:SetText(Resource[language][6]..":");
	self.TrimColor=GaranStuff.MoorMap.ColorPicker();
	self.TrimColor:SetParent(self.OptionsPanel);
	self.TrimColor:SetPosition(self.TrimCaption:GetLeft()+self.TrimCaption:GetWidth()+5,self.TrimCaption:GetTop()-1);
	self.TrimColor:SetTrimColor(trimColor);
	self.TrimColor:SetColor(trimColor);
	self.TrimColor.ColorChanged=function()
		self:SetTrimColor(self.TrimColor:GetColor());
	end

	self.BackCaption=Turbine.UI.Label();
	self.BackCaption:SetParent(self.OptionsPanel);
	self.BackCaption:SetPosition(10,self.TrimColor:GetTop()+self.TrimColor:GetHeight()+9);
	self.BackCaption:SetSize(self.OptionsPanel:GetWidth()-301,18);
	self.BackCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.BackCaption:SetForeColor(fontColor);
	self.BackCaption:SetText(Resource[language][7]..":");
	self.BackColor=GaranStuff.MoorMap.ColorPicker();
	self.BackColor:SetParent(self.OptionsPanel);
	self.BackColor:SetPosition(self.BackCaption:GetLeft()+self.BackCaption:GetWidth()+5,self.BackCaption:GetTop()-1);
	self.BackColor:SetTrimColor(trimColor);
	self.BackColor:SetColor(backColor);
	self.BackColor.ColorChanged=function()
		self:SetBackColor(self.BackColor:GetColor());
	end

	self.FontCaption=Turbine.UI.Label();
	self.FontCaption:SetParent(self.OptionsPanel);
	self.FontCaption:SetPosition(10,self.BackColor:GetTop()+self.BackColor:GetHeight()+9);
	self.FontCaption:SetSize(self.OptionsPanel:GetWidth()-301,18);
	self.FontCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.FontCaption:SetForeColor(fontColor);
	self.FontCaption:SetText(Resource[language][8]..":"); --"Font Color:");
	self.FontColor=GaranStuff.MoorMap.ColorPicker();
	self.FontColor:SetParent(self.OptionsPanel);
	self.FontColor:SetPosition(self.FontCaption:GetLeft()+self.FontCaption:GetWidth()+5,self.FontCaption:GetTop()-1);
	self.FontColor:SetTrimColor(trimColor);
	self.FontColor:SetColor(fontColor);
	self.FontColor.ColorChanged=function()
		self:SetFontColor(self.FontColor:GetColor());
	end

	self.HeadingsCaption=Turbine.UI.Label();
	self.HeadingsCaption:SetParent(self.OptionsPanel);
	self.HeadingsCaption:SetPosition(10,self.FontColor:GetTop()+self.FontColor:GetHeight()+9);
	self.HeadingsCaption:SetSize(self.OptionsPanel:GetWidth()-301,18);
	self.HeadingsCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.HeadingsCaption:SetForeColor(fontColor);
	self.HeadingsCaption:SetText(Resource[language][15]..":");
	self.HeadingsColor=GaranStuff.MoorMap.ColorPicker();
	self.HeadingsColor:SetParent(self.OptionsPanel);
	self.HeadingsColor:SetPosition(self.HeadingsCaption:GetLeft()+self.HeadingsCaption:GetWidth()+5,self.HeadingsCaption:GetTop()-1);
	self.HeadingsColor:SetTrimColor(trimColor);
	self.HeadingsColor:SetColor(headingsColor);
	self.HeadingsColor.ColorChanged=function()
		self:SetHeadingsColor(self.HeadingsColor:GetColor());
	end

	self.ListTextCaption=Turbine.UI.Label();
	self.ListTextCaption:SetParent(self.OptionsPanel);
	self.ListTextCaption:SetPosition(10,self.HeadingsColor:GetTop()+self.HeadingsColor:GetHeight()+9);
	self.ListTextCaption:SetSize(self.OptionsPanel:GetWidth()-301,18);
	self.ListTextCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.ListTextCaption:SetForeColor(fontColor);
	self.ListTextCaption:SetText(Resource[language][16]..":");
	self.ListTextColor=GaranStuff.MoorMap.ColorPicker();
	self.ListTextColor:SetParent(self.OptionsPanel);
	self.ListTextColor:SetPosition(self.ListTextCaption:GetLeft()+self.ListTextCaption:GetWidth()+5,self.ListTextCaption:GetTop()-1);
	self.ListTextColor:SetTrimColor(trimColor);
	self.ListTextColor:SetColor(listTextColor);
	self.ListTextColor.ColorChanged=function()
		self:SetListTextColor(self.ListTextColor:GetColor());
	end

	self.ResetColors=Turbine.UI.Lotro.Button();
	self.ResetColors:SetParent(self.OptionsPanel);
	self.ResetColors:SetSize(160,20);
	self.ResetColors:SetPosition((self.OptionsPanel:GetWidth()-self.ResetColors:GetWidth())/2,self.ListTextColor:GetTop()+self.ListTextColor:GetHeight()+9);
	self.ResetColors:SetText(Resource[language][9]);
	self.ResetColors.Click=function()
		trimColor=Turbine.UI.Color(.2,.5,.9);
		fontColor=Turbine.UI.Color(1,.9,.5);
		backColor=Turbine.UI.Color(.05,.05,.05);
		headingsColor=Turbine.UI.Color(1,1,1);
		listTextColor=Turbine.UI.Color(1,1,1);
		self.TrimColor:SetColor(trimColor);
		self.FontColor:SetColor(fontColor);
		self.BackColor:SetColor(backColor);
		self.HeadingsColor:SetColor(headingsColor);
		self.ListTextColor:SetColor(listTextColor);
	end

	self.OpacityCaption=Turbine.UI.Label();
	self.OpacityCaption:SetParent(self.OptionsPanel);
	self.OpacityCaption:SetPosition(10,self.ResetColors:GetTop()+self.ResetColors:GetHeight()+9);
	self.OpacityCaption:SetSize(130,18);
	self.OpacityCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.OpacityCaption:SetForeColor(fontColor);
	self.OpacityCaption:SetText(Resource[language][133]..":");
	self.OpacityScrollbar=Turbine.UI.Lotro.ScrollBar();
	self.OpacityScrollbar:SetOrientation(Turbine.UI.Orientation.Horizontal);
	self.OpacityScrollbar:SetParent(self.OptionsPanel)
	self.OpacityScrollbar:SetPosition(self.OpacityCaption:GetLeft()+self.OpacityCaption:GetWidth()+5,self.OpacityCaption:GetTop());
	self.OpacityScrollbar:SetSize(self.OptionsPanel:GetWidth()-self.OpacityCaption:GetWidth()-self.OpacityCaption:GetLeft()-15,10);
	self.OpacityScrollbar:SetBackColor(Turbine.UI.Color(0,0,0));
	self.OpacityScrollbar:SetMinimum(0);
	self.OpacityScrollbar:SetMaximum(100);
	self.OpacityScrollbar.OriginalValue=100;
	self.OpacityScrollbar.ValueChanged=function()
		mapWindow.Map:SetOpacity(self.OpacityScrollbar:GetValue()/100);

--		local color=self.ColorSwatch:GetBackColor();
--		color.R=self.OpacityScrollbar:GetValue()/self.OpacityScrollbar:GetMaximum()
--		self.ColorSwatch:SetBackColor(color);
--		self:ColorChanged();
	end
-- **** There's a MAJOR BUG with checkboxes, they don't always change Checked value when you click IN the box, only on the label :(
-- so we implement the base checkbox class and provide our own image that we can forward mouse clicks on to here...
-- yeah, it's hokey, but it works as a place holder until Turbine fixes their Checkboxes


-- Load Minimized
	self.LoadMinimizedCB=Turbine.UI.Lotro.CheckBox();
	self.LoadMinimizedCB:SetParent(self.OptionsPanel);
	self.LoadMinimizedCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.LoadMinimizedCB:SetForeColor(fontColor);
	self.LoadMinimizedCB:SetSize(self.OptionsPanel:GetWidth()-15,18);
	self.LoadMinimizedCB:SetPosition(10,self.OpacityCaption:GetTop()+self.OpacityCaption:GetHeight()+4);
	self.LoadMinimizedCB:SetText(Resource[language][17]);

	self.LMCBIcon=Turbine.UI.Label() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.LMCBIcon:SetParent(self.OptionsPanel);
	self.LMCBIcon:SetSize(self.LoadMinimizedCB:GetSize());
	self.LMCBIcon:SetPosition(self.LoadMinimizedCB:GetPosition());
	self.LMCBIcon.MouseClick=function()
		self.LoadMinimizedCB:SetChecked(not self.LoadMinimizedCB:IsChecked());
	end
	self.LMCBIcon:SetZOrder(self.LoadMinimizedCB:GetZOrder()+1);

-- Show Icon when Minimized
	self.ShowIconWhenMinimizedCB=Turbine.UI.Lotro.CheckBox();
	self.ShowIconWhenMinimizedCB:SetParent(self.OptionsPanel);
	self.ShowIconWhenMinimizedCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.ShowIconWhenMinimizedCB:SetForeColor(fontColor);
	self.ShowIconWhenMinimizedCB:SetSize(self.OptionsPanel:GetWidth()-15,18);
	self.ShowIconWhenMinimizedCB:SetPosition(10,self.LoadMinimizedCB:GetTop()+self.LoadMinimizedCB:GetHeight()+4);
	self.ShowIconWhenMinimizedCB:SetText(Resource[language][18]);

	self.SIWMCBIcon=Turbine.UI.Label() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	self.SIWMCBIcon:SetParent(self.OptionsPanel);
	self.SIWMCBIcon:SetSize(self.ShowIconWhenMinimizedCB:GetSize());
	self.SIWMCBIcon:SetPosition(self.ShowIconWhenMinimizedCB:GetPosition());
	self.SIWMCBIcon.MouseClick=function()
		self.ShowIconWhenMinimizedCB:SetChecked(not self.ShowIconWhenMinimizedCB:IsChecked());
	end
	self.SIWMCBIcon:SetZOrder(self.ShowIconWhenMinimizedCB:GetZOrder()+1);

-- Other Options ?

--** SAVE AND CANCEL
	self.SaveButton=Turbine.UI.Lotro.Button();
	self.SaveButton:SetParent(self);
	self.SaveButton:SetSize(100,20);
	self.SaveButton:SetPosition(20,self:GetHeight()-40);
	self.SaveButton:SetText(Resource[language][11]);
	self.SaveButton.Click=function()
		local hasError=false;
		-- validate option values

		if hasError then
			self.ErrorLabel:SetVisible(true);
			self.HadErrors=true;
			self.ErrorFadeTime=Turbine.Engine:GetGameTime()+3;
			self:SetWantsUpdates(true);
		else
			rb=self.LoadMinimizedCB:IsChecked();
			mapWindow:SetLoadMinimized(rb);
			rb=self.ShowIconWhenMinimizedCB:IsChecked();
			mapWindow:SetShowIconWhenMinimized(rb);
			fontColor=self.FontColor:GetColor();
			trimColor=self.TrimColor:GetColor();
			backColor=self.BackColor:GetColor();
			headingsColor=self.HeadingsColor:GetColor();
			listTextColor=self.ListTextColor:GetColor();

			language=self.LanguageList:GetValue();

			mapWindow:SetFontColor();
			mapWindow:SetTrimColor();
			mapWindow:SetBackColor();
			mapWindow:SetHeadingsColor();
			mapWindow:SetLanguage();
			mapWindow:SetListTextColor();
			self:SetVisible(false);
			mapWindow.NeedsRefresh=true;
			mapWindow:SetWantsUpdates(true);
			annotWindow:SetLanguage();
		end
	end

	self.CancelButton=Turbine.UI.Lotro.Button();
	self.CancelButton:SetParent(self);
	self.CancelButton:SetSize(100,20);
	self.CancelButton:SetPosition(self:GetWidth()-20-self.CancelButton:GetWidth(),self:GetHeight()-40);
	self.CancelButton:SetText(Resource[language][12]);
	self.CancelButton.Click=function()
		mapWindow.Map:SetOpacity(self.OpacityScrollbar.OriginalValue);
		self.FontColor:SetColor(fontColor);
		self.TrimColor:SetColor(trimColor);
		self.BackColor:SetColor(backColor);
		self.HeadingsColor:SetColor(headingsColor);
		self:SetVisible(false);
	end

	self.ErrorLabel=Turbine.UI.Label();
	self.ErrorLabel:SetParent(self);
	self.ErrorLabel:SetText("Adjusted Invalid Values")
	self.ErrorLabel:SetPosition(self.SaveButton:GetLeft()+self.SaveButton:GetWidth(),self.SaveButton:GetTop());
	self.ErrorLabel:SetSize(self.CancelButton:GetLeft()-(self.ErrorLabel:GetLeft()),self.SaveButton:GetHeight());
	self.ErrorLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro18);
	self.ErrorLabel:SetForeColor(Turbine.UI.Color(1,0,0));
	self.ErrorLabel:SetVisible(false);
	self.ErrorLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);

	self.LanguageList:SetZOrder(self.ErrorLabel:GetZOrder()+1);

	self.VisibleChanged=function(sender,args)
		if self:IsVisible() then
			-- refresh the options status to reflect current values
			self.OpacityScrollbar:SetValue(math.floor(mapWindow.Map:GetOpacity()*100));
			self.OpacityScrollbar.OriginalValue=mapWindow.Map:GetOpacity();
			self.LoadMinimizedCB:SetChecked(mapWindow:GetLoadMinimized());
			self.ShowIconWhenMinimizedCB:SetChecked(mapWindow:GetShowIconWhenMinimized());
			local index;
			for index=1,self.LanguageList.ListData:GetItemCount() do
				if self.LanguageList.ListData:GetItem(index):GetValue()==language then
					self.LanguageList:SetSelectedIndex(index);
					break;
				end
			end
			self:SetLanguage(language);
		end
	end
	self.Update=function(sender,args)
		if self.HadErrors then
			if Turbine.Engine:GetGameTime()>self.ErrorFadeTime then
				self:SetWantsUpdates(false);
				self.ErrorLabel:SetVisible(false);
				self.HadErrors=false
			end
		end
	end
	self.SetTrimColor=function(sender,color)
		self.LanguageList:SetBorderColor(color);
		self.FontColor:SetTrimColor(color);
		self.TrimColor:SetTrimColor(color);
		self.BackColor:SetTrimColor(color);
		self.HeadingsColor:SetTrimColor(color);
		self.ListTextColor:SetTrimColor(color);
	end
	self.SetBackColor=function(sender,color)
		self.LanguageList:SetBackColor(color);
		self.LanguageList:SetCurrentBackColor(color);
		self.OptionsPanel:SetBackColor(color);
		self.FontColor:SetBackColor(color);
		self.TrimColor:SetBackColor(color);
		self.BackColor:SetBackColor(color);
		self.HeadingsColor:SetBackColor(color);
		self.ListTextColor:SetBackColor(color);
	end
	self.SetFontColor=function(sender,color)
		self.LanguageCaption:SetForeColor(color);
		self.LoadMinimizedCB:SetForeColor(color);
		self.ShowIconWhenMinimizedCB:SetForeColor(color);
		self.TrimCaption:SetForeColor(color);
		self.FontCaption:SetForeColor(color);
		self.BackCaption:SetForeColor(color);
		self.HeadingsCaption:SetForeColor(color);
		self.ListTextCaption:SetForeColor(color);
		self.OpacityCaption:SetForeColor(color);
	end
	self.SetHeadingsColor=function(sender,color)
		self.OptionsCaption:SetForeColor(color);
	end
	self.SetListTextColor=function(sender,color)
		self.LanguageList:SetTextColor(color);
	end

	self.SetLanguage=function(sender,tmpLanguage)
		self:SetText(Resource[tmpLanguage][3]);
		self.OptionsCaption:SetText(Resource[tmpLanguage][4]..":");
		self.LanguageCaption:SetText(Resource[tmpLanguage][5]..":");
		self.TrimCaption:SetText(Resource[tmpLanguage][6]..":");
		self.BackCaption:SetText(Resource[tmpLanguage][7]..":");
		self.FontCaption:SetText(Resource[tmpLanguage][8]..":");
		self.HeadingsCaption:SetText(Resource[tmpLanguage][15]..":");
		self.ListTextCaption:SetText(Resource[tmpLanguage][16]..":");
		self.ResetColors:SetText(Resource[tmpLanguage][9]);
		self.OpacityCaption:SetText(Resource[tmpLanguage][133]..":");

		self.LoadMinimizedCB:SetText(Resource[tmpLanguage][17]);
		self.ShowIconWhenMinimizedCB:SetText(Resource[tmpLanguage][18]);

		self.SaveButton:SetText(Resource[tmpLanguage][11]);
		self.CancelButton:SetText(Resource[tmpLanguage][12]);
	end
end
